"""
PPPPPPPPPPPPPPPPP                                     tttt         hhhhhhh
P::::::::::::::::P                                 ttt:::t         h:::::h
P::::::PPPPPP:::::P                                t:::::t         h:::::h
PP:::::P     P:::::P                               t:::::t         h:::::h
  P::::P     P:::::Pyyyyyyy           yyyyyyyttttttt:::::ttttttt    h::::h hhhhh          ooooooooooo   nnnn  nnnnnnnn
  P::::P     P:::::P y:::::y         y:::::y t:::::::::::::::::t    h::::hh:::::hhh     oo:::::::::::oo n:::nn::::::::nn
  P::::PPPPPP:::::P   y:::::y       y:::::y  t:::::::::::::::::t    h::::::::::::::hh  o:::::::::::::::on::::::::::::::nn
  P:::::::::::::PP     y:::::y     y:::::y   tttttt:::::::tttttt    h:::::::hhh::::::h o:::::ooooo:::::onn:::::::::::::::n
  P::::PPPPPPPPP        y:::::y   y:::::y          t:::::t          h::::::h   h::::::ho::::o     o::::o  n:::::nnnn:::::n
  P::::P                 y:::::y y:::::y           t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                  y:::::y:::::y            t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                   y:::::::::y             t:::::t    tttttth:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
PP::::::PP                  y:::::::y              t::::::tttt:::::th:::::h     h:::::ho:::::ooooo:::::o  n::::n    n::::n
P::::::::P                   y:::::y               tt::::::::::::::th:::::h     h:::::ho:::::::::::::::o  n::::n    n::::n
P::::::::P                  y:::::y                  tt:::::::::::tth:::::h     h:::::h oo:::::::::::oo   n::::n    n::::n
PPPPPPPPPP                 y:::::y                     ttttttttttt  hhhhhhh     hhhhhhh   ooooooooooo     nnnnnn    nnnnnn
                          y:::::y
                         y:::::y
                        y:::::y
                       y:::::y
                      yyyyyyy
    ______           __                       __         _ __  __
   / ____/___  _____/ /_____ ____  __________/ /_  _____(_) /_/ /____  ____  ___
  / /_  / __ \/ ___/ __/ __ `/ _ \/ ___/ ___/ __ \/ ___/ / __/ __/ _ \/ __ \/ _ \
 / __/ / /_/ / /  / /_/ /_/ /  __(__  ) /__/ / / / /  / / /_/ /_/  __/ / / /  __/
/_/    \____/_/   \__/\__, /\___/____/\___/_/ /_/_/  /_/\__/\__/\___/_/ /_/\___/
                     /____/
"""
#Erstellt von Paul Freudenberger
#Erstellt am 08.01.2020
#ASCII Art erstellt mit http://www.network-science.de/ascii/ , font = doh & font = slant

#===============================
#= Tutorial: Datei Operationen =
#===============================

import os

print("In diesem Programm wird das Arbeiten mit Ordnern und Dateien demonstriert.")

#=== Lektion 1: Testordnerstruktur und Dateien anlegen ===

startordner = "C:/TEMP/Pythontest"
unterordner = ["Bilder", "Dokumente", "Music", "Videos"]
dateien = ["Testbild1.jpg", "Testdokument1.docx", "Testmusik.mp3", "Testvideo.mp4"]

if not os.path.isdir(startordner):
	os.makedirs(startordner)

for i in range(len(unterordner)):
	unterordner_vollerpfad = startordner + os.sep + unterordner[i]
	datei_vollerpfad = unterordner_vollerpfad + os.sep + dateien[i]
	if not os.path.isdir(unterordner_vollerpfad):
		os.makedirs(unterordner_vollerpfad)
	f = open(datei_vollerpfad, "w")
	f.write("Hallo Welt!\n")
	f.write("Das ist eine Testdatei\n")
	f.close()

print("Es wurde eine Testordnerstruktur nach dem Schema [Startordner]\[Unterordner]\[Testdatei] angelegt.")
input("Drücken Sie eine beliebige Taste . . .")

#=== Lektion 2: Durch einzelnen Ordner loopen ===
print("Der Ordner {} enthält folgende Elemente:".format(startordner))
for elemname in os.listdir(startordner):
	elem_vollerpfad = startordner + os.sep + elemname
	if os.path.isdir(elem_vollerpfad):
		print("Ordner: {}".format(elem_vollerpfad))
	elif os.path.isfile(elem_vollerpfad):
		print("Datei: {}".format(elem_vollerpfad))

input("Drücken Sie eine beliebige Taste . . .")

#=== Lektion 3: Recursiv durch Ordnerstrukturen loopen  ===

for aktuellerordner, unterordner, dateien in os.walk(startordner):
	for unterordnername in unterordner:
		unterordnerpfad = aktuellerordner + os.sep + unterordnername
		print("Ordner: {}".format(unterordnerpfad))
	
	for dateiname in dateien:
		dateipfad = aktuellerordner + os.sep + dateiname
		if dateipfad.endswith(".txt"):
			print("*.txt-Datei: {}".format(dateipfad))
		else:
			print("Datei: {}".format(dateipfad))

input("Drücken Sie eine beliebige Taste . . .")
