"""
PPPPPPPPPPPPPPPPP                                     tttt         hhhhhhh
P::::::::::::::::P                                 ttt:::t         h:::::h
P::::::PPPPPP:::::P                                t:::::t         h:::::h
PP:::::P     P:::::P                               t:::::t         h:::::h
  P::::P     P:::::Pyyyyyyy           yyyyyyyttttttt:::::ttttttt    h::::h hhhhh          ooooooooooo   nnnn  nnnnnnnn
  P::::P     P:::::P y:::::y         y:::::y t:::::::::::::::::t    h::::hh:::::hhh     oo:::::::::::oo n:::nn::::::::nn
  P::::PPPPPP:::::P   y:::::y       y:::::y  t:::::::::::::::::t    h::::::::::::::hh  o:::::::::::::::on::::::::::::::nn
  P:::::::::::::PP     y:::::y     y:::::y   tttttt:::::::tttttt    h:::::::hhh::::::h o:::::ooooo:::::onn:::::::::::::::n
  P::::PPPPPPPPP        y:::::y   y:::::y          t:::::t          h::::::h   h::::::ho::::o     o::::o  n:::::nnnn:::::n
  P::::P                 y:::::y y:::::y           t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                  y:::::y:::::y            t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                   y:::::::::y             t:::::t    tttttth:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
PP::::::PP                  y:::::::y              t::::::tttt:::::th:::::h     h:::::ho:::::ooooo:::::o  n::::n    n::::n
P::::::::P                   y:::::y               tt::::::::::::::th:::::h     h:::::ho:::::::::::::::o  n::::n    n::::n
P::::::::P                  y:::::y                  tt:::::::::::tth:::::h     h:::::h oo:::::::::::oo   n::::n    n::::n
PPPPPPPPPP                 y:::::y                     ttttttttttt  hhhhhhh     hhhhhhh   ooooooooooo     nnnnnn    nnnnnn
                          y:::::y
                         y:::::y
                        y:::::y
                       y:::::y
                      yyyyyyy
    ____                                                  _
   / __ \_________  ____ __________ _____ ___  ____ ___  (_)__  ________  _____
  / /_/ / ___/ __ \/ __ `/ ___/ __ `/ __ `__ \/ __ `__ \/ / _ \/ ___/ _ \/ ___/
 / ____/ /  / /_/ / /_/ / /  / /_/ / / / / / / / / / / / /  __/ /  /  __/ /
/_/   /_/   \____/\__, /_/   \__,_/_/ /_/ /_/_/ /_/ /_/_/\___/_/   \___/_/
                 /____/
"""
#Erstellt von Paul Freudenberger
#Erstellt am 14.01.2020
#ASCII Art erstellt mit http://www.network-science.de/ascii/ , font = doh & font = slant

#========================
#= Tutorial: Exceptions =
#========================

import os

fehlendedatei = "C:/diese/datei/kann/es/nicht/geben.txt"
if os.name == "nt":
	fehlendedatei = fehlendedatei.replace("/","\\")

#=== Lektion 1: Exceptions ===
try:
	f = open(fehlendedatei, "r")
	inhalt = f.read()
	arrzeilen = inhalt.split("\n")
	for zeile in arrzeilen:
		print("Neue Zeile: {}".format(zeile))
except FileNotFoundError as e:
	errno, strerrtext = e.args
	print("\nAnscheinend existiert die Datei, die sie lesen möchten nicht.\nFehlermeldung: {} - {}".format(errno, strerrtext))
except:
	print("\nUps, da ist ein Fehler passiert...")

input("Drücken Sie eine beliebige Taste . . .")

#=== Lektion 2: Exceptions ignorieren ===
try:
	f = open(fehlendedatei, "r")
except:
	pass

print("\nMit 'pass' kann man das Exceptions einfach ignorieren")
input("Drücken Sie eine beliebige Taste . . .")

#=== Lektion 3: Unspezifizierte Exceptions ===
try:
	raise Exception("Mit Absicht Fehler auslösen")
except Exception as e:
	#OPTIONAL = as e 
	print("\nAuf diese Weise kann man selbst gezielt Fehler auslösen.\nFehlermeldung: {}".format(e))

input("Drücken Sie eine beliebige Taste . . .")

#=== Lektion 4: Benutzerdefinierte Exceptions ===
class DummheitsError(Exception):
	pass

try:
	raise DummheitsError("Dieser Fehler trat wegen Dummheit auf")
except DummheitsError as e:
	#OPTIONAL = as e 
	print("\nAuf diese Weise kann man selbst Fehlerarten erfinden.\nFehlermeldung: {}".format(e))

input("Drücken Sie eine beliebige Taste . . .")
