"""
PPPPPPPPPPPPPPPPP                                     tttt         hhhhhhh
P::::::::::::::::P                                 ttt:::t         h:::::h
P::::::PPPPPP:::::P                                t:::::t         h:::::h
PP:::::P     P:::::P                               t:::::t         h:::::h
  P::::P     P:::::Pyyyyyyy           yyyyyyyttttttt:::::ttttttt    h::::h hhhhh          ooooooooooo   nnnn  nnnnnnnn
  P::::P     P:::::P y:::::y         y:::::y t:::::::::::::::::t    h::::hh:::::hhh     oo:::::::::::oo n:::nn::::::::nn
  P::::PPPPPP:::::P   y:::::y       y:::::y  t:::::::::::::::::t    h::::::::::::::hh  o:::::::::::::::on::::::::::::::nn
  P:::::::::::::PP     y:::::y     y:::::y   tttttt:::::::tttttt    h:::::::hhh::::::h o:::::ooooo:::::onn:::::::::::::::n
  P::::PPPPPPPPP        y:::::y   y:::::y          t:::::t          h::::::h   h::::::ho::::o     o::::o  n:::::nnnn:::::n
  P::::P                 y:::::y y:::::y           t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                  y:::::y:::::y            t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                   y:::::::::y             t:::::t    tttttth:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
PP::::::PP                  y:::::::y              t::::::tttt:::::th:::::h     h:::::ho:::::ooooo:::::o  n::::n    n::::n
P::::::::P                   y:::::y               tt::::::::::::::th:::::h     h:::::ho:::::::::::::::o  n::::n    n::::n
P::::::::P                  y:::::y                  tt:::::::::::tth:::::h     h:::::h oo:::::::::::oo   n::::n    n::::n
PPPPPPPPPP                 y:::::y                     ttttttttttt  hhhhhhh     hhhhhhh   ooooooooooo     nnnnnn    nnnnnn
                          y:::::y
                         y:::::y
                        y:::::y
                       y:::::y
                      yyyyyyy
    ___       __                                __
   /   | ____/ /   ______ _____  ________  ____/ /
  / /| |/ __  / | / / __ `/ __ \/ ___/ _ \/ __  /
 / ___ / /_/ /| |/ / /_/ / / / / /__/  __/ /_/ /
/_/  |_\__,_/ |___/\__,_/_/ /_/\___/\___/\__,_/
"""
#Created by Paul Freudenberger
#Created on 03.01.2020
#ASCII Art generated with http://www.network-science.de/ascii/ , font = doh & font = slant

#=====================
#= Tutorial: Imports =
#=====================

import os
import subprocess
import pylab

print("In this program imports are demonstrated.")
print("In other programming languages this process is also known as 'Include'.")

#=== Lecture 1: The os-Module ===
#retcode = os.system("ipconfig")
retcode = os.system("ipconfig > NUL")

if retcode == 0:
	print("The CMD-Call ended successfull without errors.")
else:
	print("The CMD-Call ended with the following error: Error {}".format(retcode))

input("Press any key to continue . . .")

#=== Lecture 2: The subprocess-Module ===
bytesoutput = subprocess.check_output("ipconfig")
myoutput = bytesoutput.decode("utf-8")
print("You know what's very useful...\nVia subprozess the output can be redirected into a variable.")
print("Look:\n{}".format(myoutput))

input("Press any key to continue . . .")

#=== Lecutre 3: The pylab-Module (Also known as matplotlib) ===
plotsavepath = "C:/TEMP/testplot.png"
xvalues = [0,1,2,3,4,5,6,7,8,9,10]
yvalues = [10,9,8,7,6,5,4,3,2,1,0]

parentindex = plotsavepath.rfind("/")
parentfolder = plotsavepath[:parentindex]
if os.name == "nt":
	plotsavepath = plotsavepath.replace("/","\\")
	parentfolder = parentfolder.replace("/","\\")
pylab.plot(xvalues, yvalues)
pylab.title("Testdiagraph")
pylab.legend(("Current temperature", "Other stuff"))
pylab.xlabel("X-Values")
pylab.ylabel("Y-Values")
pylab.savefig(plotsavepath, dpi=300)        #dpi increases the resulting resolution. (300 dpi = 1920x1440px)
pylab.close()
#pylab.show()
os.system("start explorer.exe {}".format(parentfolder))
