"""
PPPPPPPPPPPPPPPPP                                     tttt         hhhhhhh
P::::::::::::::::P                                 ttt:::t         h:::::h
P::::::PPPPPP:::::P                                t:::::t         h:::::h
PP:::::P     P:::::P                               t:::::t         h:::::h
  P::::P     P:::::Pyyyyyyy           yyyyyyyttttttt:::::ttttttt    h::::h hhhhh          ooooooooooo   nnnn  nnnnnnnn
  P::::P     P:::::P y:::::y         y:::::y t:::::::::::::::::t    h::::hh:::::hhh     oo:::::::::::oo n:::nn::::::::nn
  P::::PPPPPP:::::P   y:::::y       y:::::y  t:::::::::::::::::t    h::::::::::::::hh  o:::::::::::::::on::::::::::::::nn
  P:::::::::::::PP     y:::::y     y:::::y   tttttt:::::::tttttt    h:::::::hhh::::::h o:::::ooooo:::::onn:::::::::::::::n
  P::::PPPPPPPPP        y:::::y   y:::::y          t:::::t          h::::::h   h::::::ho::::o     o::::o  n:::::nnnn:::::n
  P::::P                 y:::::y y:::::y           t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                  y:::::y:::::y            t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                   y:::::::::y             t:::::t    tttttth:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
PP::::::PP                  y:::::::y              t::::::tttt:::::th:::::h     h:::::ho:::::ooooo:::::o  n::::n    n::::n
P::::::::P                   y:::::y               tt::::::::::::::th:::::h     h:::::ho:::::::::::::::o  n::::n    n::::n
P::::::::P                  y:::::y                  tt:::::::::::tth:::::h     h:::::h oo:::::::::::oo   n::::n    n::::n
PPPPPPPPPP                 y:::::y                     ttttttttttt  hhhhhhh     hhhhhhh   ooooooooooo     nnnnnn    nnnnnn
                          y:::::y
                         y:::::y
                        y:::::y
                       y:::::y
                      yyyyyyy
    ___       __                                __
   /   | ____/ /   ______ _____  ________  ____/ /
  / /| |/ __  / | / / __ `/ __ \/ ___/ _ \/ __  /
 / ___ / /_/ /| |/ / /_/ / / / / /__/  __/ /_/ /
/_/  |_\__,_/ |___/\__,_/_/ /_/\___/\___/\__,_/
"""
#Created by Paul Freudenberger
#Created on 08.01.2020
#ASCII Art generated with http://www.network-science.de/ascii/ , font = doh & font = slant

#=============================
#= Tutorial: File Operations =
#=============================

import os

print("In this program working with files and folders is demonstrated.")

#=== Lecture 1: Create Testfolderstructure and files ===

startfolder = "C:/TEMP/Pythontest"
subfolders = ["Bilder", "Dokumente", "Music", "Videos"]
files = ["Testpicture1.jpg", "Testdocument1.docx", "Testmusic.mp3", "Testvideo.mp4"]

if not os.path.isdir(startfolder):
	os.makedirs(startfolder)

for i in range(len(subfolders)):
	subfolder_fullpath = startfolder + os.sep + subfolders[i]
	file_fullpath = subfolder_fullpath + os.sep + files[i]
	if not os.path.isdir(subfolder_fullpath):
		os.makedirs(subfolder_fullpath)
	f = open(file_fullpath, "w")
	f.write("Hello World!\n")
	f.write("This is a test file\n")
	f.close()

print("A testfolderstructure has been created using the scheme [Startfolder]\[Subfolder]\[Testfile].")
input("Press any key to continue . . .")

#=== Lecture 2: Loop through a single folder ===
print("The folder {} contains the following elements:".format(startfolder))
for elemname in os.listdir(startfolder):
	elemfullpath = startfolder + os.sep + elemname
	if os.path.isdir(elemfullpath):
		print("Folder: {}".format(elemfullpath))
	elif os.path.isfile(elemfullpath):
		print("File: {}".format(elemfullpath))

input("Press any key to continue . . .")

#=== Lecture 3: Loop recursive through folder structures ===

for currentdir, subfolders, files in os.walk(startfolder):
	for subfoldername in subfolders:
		subfolderpath = currentdir + os.sep + subfoldername
		print("Folder: {}".format(subfolderpath))
	
	for filename in files:
		filepath = currentdir + os.sep + filename
		if filepath.endswith(".txt"):
			print("*.txt-File: {}".format(filepath))
		else:
			print("File: {}".format(filepath))

input("Press any key to continue . . .")
