"""
PPPPPPPPPPPPPPPPP                                     tttt         hhhhhhh
P::::::::::::::::P                                 ttt:::t         h:::::h
P::::::PPPPPP:::::P                                t:::::t         h:::::h
PP:::::P     P:::::P                               t:::::t         h:::::h
  P::::P     P:::::Pyyyyyyy           yyyyyyyttttttt:::::ttttttt    h::::h hhhhh          ooooooooooo   nnnn  nnnnnnnn
  P::::P     P:::::P y:::::y         y:::::y t:::::::::::::::::t    h::::hh:::::hhh     oo:::::::::::oo n:::nn::::::::nn
  P::::PPPPPP:::::P   y:::::y       y:::::y  t:::::::::::::::::t    h::::::::::::::hh  o:::::::::::::::on::::::::::::::nn
  P:::::::::::::PP     y:::::y     y:::::y   tttttt:::::::tttttt    h:::::::hhh::::::h o:::::ooooo:::::onn:::::::::::::::n
  P::::PPPPPPPPP        y:::::y   y:::::y          t:::::t          h::::::h   h::::::ho::::o     o::::o  n:::::nnnn:::::n
  P::::P                 y:::::y y:::::y           t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                  y:::::y:::::y            t:::::t          h:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
  P::::P                   y:::::::::y             t:::::t    tttttth:::::h     h:::::ho::::o     o::::o  n::::n    n::::n
PP::::::PP                  y:::::::y              t::::::tttt:::::th:::::h     h:::::ho:::::ooooo:::::o  n::::n    n::::n
P::::::::P                   y:::::y               tt::::::::::::::th:::::h     h:::::ho:::::::::::::::o  n::::n    n::::n
P::::::::P                  y:::::y                  tt:::::::::::tth:::::h     h:::::h oo:::::::::::oo   n::::n    n::::n
PPPPPPPPPP                 y:::::y                     ttttttttttt  hhhhhhh     hhhhhhh   ooooooooooo     nnnnnn    nnnnnn
                          y:::::y
                         y:::::y
                        y:::::y
                       y:::::y
                      yyyyyyy
    ____
   / __ \_________  ____ __________ _____ ___  ____ ___  ___  _____
  / /_/ / ___/ __ \/ __ `/ ___/ __ `/ __ `__ \/ __ `__ \/ _ \/ ___/
 / ____/ /  / /_/ / /_/ / /  / /_/ / / / / / / / / / / /  __/ /
/_/   /_/   \____/\__, /_/   \__,_/_/ /_/ /_/_/ /_/ /_/\___/_/
                 /____/
"""
#Created by Paul Freudenberger
#Created on 14.01.2020
#ASCII Art generated with http://www.network-science.de/ascii/ , font = doh & font = slant

#========================
#= Tutorial: Exceptions =
#========================

import os

missingfile = "C:/this/file/can/not/exist.txt"
if os.name == "nt":
	missingfile = missingfile.replace("/","\\")

#=== Lecture 1: Exceptions ===
try:
	f = open(missingfile, "r")
	content = f.read()
	arrlines = content.split("\n")
	for line in arrlines:
		print("New line: {}".format(line))
except FileNotFoundError as e:
	errno, strerrtext = e.args
	print("\nIt seems the file you are trying to read does not exist.\nError message: {} - {}".format(errno, strerrtext))
except:
	print("\nOops, an error occured...")

input("Press any key to continue . . .")

#=== Lecture 2: Ignore exceptions ===
try:
	f = open(missingfile, "r")
except:
	pass

print("\nWith 'pass' you can just ignore exceptions")
input("Press any key to continue . . .")

#=== Lecture 3: Unspecific exceptions ===
try:
	raise Exception("Trigger an error on purpose")
except Exception as e:
	#OPTIONAL = as e 
	print("\nThis way you can trigger exceptions yourself.\nError message: {}".format(e))

input("Press any key to continue . . .")

#=== Lecture 4: Userdefined exceptions ===
class StupidityError(Exception):
	pass

try:
	raise StupidityError("This error happened because of stupidity")
except StupidityError as e:
	#OPTIONAL = as e 
	print("\nThis way you can invent exceptions yourself.\nError message: {}".format(e))

input("Press any key to continue . . .")
